-- scope stuff
qualityoflife = qualityoflife or {};
local q = qualityoflife;

q.modules = q.modules or {};
q.modules["QoL_ClassicHeals-TBC"] = q.modules["QoL_ClassicHeals-TBC"] or {};
local c = q.modules["QoL_ClassicHeals-TBC"];

function c:Println(str)
	if str then
		q:Println(str, "ClassicHeals");
	end
end

function c:GetAffectedPartyMemberId(memberName)
	for playerId, playerName in ipairs(q:GetPartyMembers()) do
		if playerName == memberName then
			return playerId;
		end
	end
end

function c:GetAffectedPartyUnitId(target)
	if target == "player" then
		return "player";
	elseif target == "target" then
		return "target";
	end

	target = q:RemoveRealmFromName(target);
	for partyId = 1, 5 do
		local unitId = "party" .. partyId;
		if q:RemoveRealmFromName(GetUnitName(unitId)) == target then
			return unitId;
		end

		local unitPetId = "partypet" .. partyId;
		if q:RemoveRealmFromName(GetUnitName(unitPetId)) == target then
			return unitPetId;
		end
	end
end

function c:GetAffectedRaidMemberId(memberName)
	local rm = q:GetRaidMembers();
	local raidId;

	for playerId, playerName in ipairs(rm[0]) do
		if playerName == memberName then
			raidId = playerId;
			break;
		end
	end

	for subGroupId, subGroup in pairs(rm) do
		if subGroupId > 0 then
			for playerInSubGroupId, playerName in ipairs(rm[subGroupId]) do
				if playerName == memberName then
					return raidId, subGroupId, playerInSubGroupId;
				end;
			end;
		end
	end

	if memberName == GetUnitName("player") then
		return 1, 1, 1; -- for grid, vuhdo etc.
	end
end

function c:GetAffectedRaidUnitId(target)
	if target == "player" then
		return "player";
	elseif target == "target" then
		return "target";
	end

	target = q:RemoveRealmFromName(target);
	for raidId = 1, 40 do
		local unitId = "raid" .. raidId;
		if q:RemoveRealmFromName(GetUnitName(unitId)) == target then
			return unitId;
		end

		local unitPetId = "raidpet" .. raidId;
		if q:RemoveRealmFromName(GetUnitName(unitPetId)) == target then
			return unitPetId;
		end
	end
end

function c:ShowResetDialog()
	local dialogName = c.name .. "_RESETDIALOG";
	StaticPopupDialogs[dialogName] = StaticPopupDialogs[dialogName] or {
		text = q:GetText("This will reset all ClassicHeals settings to defaults.\n\nAre you sure?"),
		button1 = q:GetText("Reset"),
		button2 = q:GetText("Cancel"),
		OnEscapePressed = function ()
			self:Hide();
		end,
		OnAccept = function()
			QOL_OPTIONS[c.name] = {};
			c:InitProfiles(true);
			c:InitOptions();
			c:SaveSettingsChanges();
			c:SetProfileValues();
			c:Println("AddOn reset complete.");
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
		preferredIndex = 3
	};
	StaticPopup_Show(dialogName);
end